{-# LANGUAGE FlexibleInstances #-}
module Adventurers where

{-- Recall the adventurers' problem from TP1. Your task
is to implement a function "cross" that describes the effect
of an adventurer moving from one side of the bridge to the
other. Recall that all adventurers take time to cross the
bridge.
--}

import DurationMonad

-- A list of adventurers (refine this as you see fit)
data Adventurer = P1 | P2 | P3 | P4 deriving Show

{-- The state of the game, i.e. the current position of each
adventurer. The function (const False) represents the initial state of
the game, with all adventurers on the left side of the
bridge. Similarly, the function (const True) represents the end state
of the game, with all adventurers on the right side of the bridge.
--}
type State = Adventurer -> Bool

instance Show State where
  show s = (show . (fmap show)) [s P1, s P2, s P3, s P4]

-- Your main task is to implement this function
cross :: (Adventurer, State) -> Duration State
cross = undefined

-- A test.
t1 = do s1 <- cross (P1, const False)
        s2 <- cross (P2, s1)
        s3 <- cross (P3, s2)
        return s3

-- Other tests?
